#ifndef __ASSIST__
#define __ASSIST__

#pragma once

#include <map>
#include <string>
#include "ImgAssist.h"

namespace GameGlobal {
	enum {
		GW_SMALL,
		GW_LARGE,
		GW_FULL,
	}GAME_WND;
	extern int titleBarHeight;
	extern int frameWidth;

	extern TCHAR g_szCurModuleFileName[MAX_PATH];
	extern TCHAR g_szCurModuleDir[MAX_PATH];
	extern TCHAR g_szCurModulePath[MAX_PATH];
	extern TCHAR g_szFna[_MAX_FNAME];
	extern TCHAR g_szExt[_MAX_EXT];
	extern TCHAR g_szAssistConfig[MAX_PATH];
	extern std::string g_strAppdir;
	extern std::string g_strGameDir;
	extern TCHAR g_szGameApp[MAX_PATH];
	extern TCHAR g_szTempDir[MAX_PATH];
	extern int nGameWndType;
	extern int nAttackCount;

	void Init();
	std::string BuildImgPath(HWND hWnd, LPCTSTR lpName = NULL);
	VOID DebugLog(CHAR* pszStr, ...);
};

// ,ǻϷڵֵ;
// Ϸ:802*627
namespace GameAssist{
	// ؼϢ;
	typedef struct __CTRL_INFO__ {
		DWORD			dwId;				// ؼid;
		std::string		strWinText;			// ؼı;
		std::string		strClassName;		// ؼ;
		HWND			hwnd;				// ؼ;
	}CtrlInfo, * pCtrlInfo;
	extern std::vector<CtrlInfo> g_vtCtrlInfo;

	typedef struct __GAMEWNDINFO__
	{
		unsigned long       lProcId;				// ID;
		HWND                hWnd;					// ̴ھ;
		std::string			strGameRoleName;		// ɫ;
		std::string			strGameZoon;			// ;
		std::string			strGameServer;			// վ
		LPVOID				pAction;				// CAction;
	}GameWndInfo, * pGameWndInfo;
	extern std::vector<GameWndInfo> g_vtGameWndInfo;
	void ClearGameInfo(std::vector<GameWndInfo> &vtGWnd);

	extern RECT g_rcRoleIdleHP ;
	extern RECT g_rcRoleIdleSP ;
	extern RECT g_rcSummonerIdleHP;
	extern RECT g_rcSummonerIdleSP;
	extern RECT g_rcRoleFightingHP;
	extern RECT g_rcRoleFightingSP;
	extern RECT g_rcSummonerFightingHP;
	extern RECT g_rcSummonerFightingSP;

	// Ϸǰ;
	void SetGameForeground(HWND hWnd);
	// жϷǷǰ;
	bool IsGameForeground(HWND hWnd);
	// תΪĻ;
	BOOL GamePos2Screen(HWND hWnd, POINT &pt, bool bOffset = false);
	// ĻתΪϷ;
	BOOL ScreenPos2Game(HWND hWnd, POINT& pt);
	// ƶ;
	void MouseMove(POINT pt, bool bSetCurPos = true);
	// 굥;
	void MouseClick();
	void MouseClick(POINT pt);
	// ˫;
	void MouseDbClick();
	void MouseDbClick(POINT pt);
	// һ;
	void MouseRClick();
	void MouseRClick(POINT pt);
	// ϶;
	void MouseDrag(POINT pt);

	// Ͱ;
	void SendKey(DWORD key, BOOL bCtrl = FALSE, BOOL bAtl = FALSE, BOOL bShift = FALSE);
	void SendKeyFast(DWORD key, BOOL bCtrl = FALSE, BOOL bAtl = FALSE, BOOL bShift = FALSE);
	// ȡаַ;
	CString GetClipboradString();
	// üаַ;
	BOOL SetClipboardString(LPCTSTR lpString);

	// ݽȡpid;
	DWORD GetProcessId(LPCTSTR lpProcessName = _T("Game.exe"));
	// ȡָĽpid;
	void GetAllProcessId(std::vector<DWORD>& vtPid, LPCTSTR lpProcessName = _T("Game.exe"));
	// ݽpidȡ̶ӦĴھ;
	HWND GetProcessMainWnd(const DWORD& dwTagetProcessId, LPCTSTR lpTagetWndName = _T("ˮ"));
	// ȡָĽ;
	HWND GetProcessMainWnd(LPCTSTR lpProcessName = _T("Game.exe"), LPCTSTR lpTagetWndName = _T("ˮ"));
	// ȡָĽ;
	void GetAllProcessMainWnd(const std::vector<DWORD>& vtPid, std::vector<GameWndInfo>& vtGWnd, LPCTSTR lpTagetWndName = _T("ˮ"));
	// ö̵ָĴ;
	extern BOOL CALLBACK EnumChildWindowCallBack(HWND hWnd, LPARAM lParam);
};

#endif // __ASSIST__