
// GameAssistDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "GameAssist.h"
#include "GameAssistDlg.h"
//#include "VideoDXGICaptor.h"
#include "MouseAssist.h"
#include "CAction.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Ӧó򡰹ڡ˵ CAboutDlg Ի

VOID DebugLog(CHAR* pszStr, ...)
{
	char szData[MAX_PATH] = { 0 };
	_stprintf_s(szData, _T("%s %s "), _T("[GameAssist] "), CTime::GetCurrentTime().Format(_T("%Y-%m-%d %H:%M:%S")).GetString());
	int len = strlen(szData);
	va_list args;
	va_start(args, pszStr);
	_vsnprintf_s(szData + len, MAX_PATH - len, MAX_PATH - len, pszStr, args);
	va_end(args);
	strcat_s(szData, "\n");
	OutputDebugStringA(szData);
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Ի
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGameAssistDlg Ի




CGameAssistDlg::CGameAssistDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGameAssistDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGameAssistDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK1, m_cbSummoner);
	DDX_Control(pDX, IDC_CHECK2, m_cbZJ);
	DDX_Control(pDX, IDC_CHECK3, m_cbZJ2);
	DDX_Control(pDX, IDC_CHECK6, m_cbAggressiveSkill);
	DDX_Control(pDX, IDC_COMBO1, m_cbGameRole);
	DDX_Control(pDX, IDC_COMBO2, m_cbZYNPC);
	DDX_Control(pDX, IDC_COMBO_SKILL_LIST, m_cb_skill_list);
}

BEGIN_MESSAGE_MAP(CGameAssistDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(BTN_OPENGAME, &CGameAssistDlg::OnBnClickedOpengame)
	ON_BN_CLICKED(IDC_BUTTON2, &CGameAssistDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CGameAssistDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CGameAssistDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CGameAssistDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CGameAssistDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CGameAssistDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CGameAssistDlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CGameAssistDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, &CGameAssistDlg::OnBnClickedButton10)
	ON_BN_CLICKED(IDC_BUTTON11, &CGameAssistDlg::OnBnClickedButton11)
	ON_BN_CLICKED(IDC_BUTTON12, &CGameAssistDlg::OnBnClickedButton12)
	ON_BN_CLICKED(IDC_BUTTON13, &CGameAssistDlg::OnBnClickedButton13)
	ON_BN_CLICKED(IDC_BUTTON14, &CGameAssistDlg::OnBnClickedButton14)
END_MESSAGE_MAP()


// CGameAssistDlg Ϣ

BOOL CGameAssistDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	GameGlobal::Init();
	GameAssist::LoadMetaGraph();

	int nIndex = 0;
	for each (auto it in GameAssist::g_mapZYNPC)
	{
		m_cbZYNPC.InsertString(nIndex++, it.first.c_str());
	}
	m_cbZYNPC.SetCurSel(0);

	OnBnClickedButton11();
	InitSkillList();

	SetDlgItemInt(IDC_EDIT7, 100);

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CGameAssistDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CGameAssistDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CGameAssistDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


HWND CGameAssistDlg::GetCurGameWnd()
{
	int nCurSel = m_cbGameRole.GetCurSel();
	if (nCurSel == CB_ERR)
		return NULL;

	GameAssist::GameWndInfo* pInfo = (GameAssist::GameWndInfo*)m_cbGameRole.GetItemDataPtr(nCurSel);
	return pInfo->hWnd;
}

GameAssist::GameWndInfo* CGameAssistDlg::GetCurGameInfo()
{
	int nCurSel = m_cbGameRole.GetCurSel();
	if (nCurSel == CB_ERR)
		return NULL;

	return (GameAssist::GameWndInfo*)m_cbGameRole.GetItemDataPtr(nCurSel);
}

void CGameAssistDlg::InitSkillList()
{
	m_cb_skill_list.AddString("F1");
	m_cb_skill_list.AddString("F2");
	m_cb_skill_list.AddString("F3");
	m_cb_skill_list.AddString("F4");
	m_cb_skill_list.AddString("F5");
	m_cb_skill_list.AddString("F6");
	m_cb_skill_list.AddString("F7");
	m_cb_skill_list.AddString("F8");
	m_cb_skill_list.SetCurSel(7);
}

void CGameAssistDlg::OnBnClickedOpengame() // Ϸ;
{
	// TODO: ڴӿؼ֪ͨ
	if (!PathFileExists(GameGlobal::g_szGameApp))
	{
		MessageBox(_T("Ϸ򲻴"), _T("ܰʾ"));
		return;
	}

	// øĿ¼ΪϷĿ¼;
	//SetCurrentDirectory(_T("E:\\dhsh\\shdata\\"));
	SetCurrentDirectory(_T("D:\\tools\\dhsh\\shdata\\"));
#if 1
	ShellExecute(NULL, "open", GameGlobal::g_szGameApp, NULL, NULL, SW_SHOWNORMAL);//SW_HIDE,ΪԶ;
	Sleep(500); // Main.exe(Լٿһ̣һ),Ҫ5;
#else
	SHELLEXECUTEINFO stuExecInfo = { 0 };
	DWORD dwExitCode = STILL_ACTIVE;
	//CString strCommandLine = _T("open");
	stuExecInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	stuExecInfo.lpFile = GameGlobal::g_szGamePath;
	stuExecInfo.lpParameters = "open";
	stuExecInfo.nShow = SW_SHOWNORMAL;
	stuExecInfo.fMask = SEE_MASK_NOCLOSEPROCESS | SEE_MASK_FLAG_NO_UI;

	if (!ShellExecuteEx(&stuExecInfo))
	{
		DWORD dwError = GetLastError();
		CString strError = _T("");
		strError.Format(_T("ִShellExecuteExʧ,:%d"), dwError);
		AfxMessageBox(strError);
		return;
	}

	HANDLE hProcess = stuExecInfo.hProcess;
	if (hProcess != NULL)
	{
		WaitForSingleObject(hProcess, INFINITE);
		CloseHandle(hProcess);
	}

#endif

	DWORD dwPID = GameAssist::GetProcessId(_T("Main.exe"));
#if 1
	EnumWindows(GameAssist::EnumChildWindowCallBack, dwPID);

	if (GameAssist::g_vtCtrlInfo.size())
	{
		GameAssist::CtrlInfo* gp = NULL;
		GameAssist::CtrlInfo* gbmin = NULL;
		GameAssist::CtrlInfo* gbentry = NULL;
		for (std::vector<GameAssist::CtrlInfo>::iterator it = GameAssist::g_vtCtrlInfo.begin(); it != GameAssist::g_vtCtrlInfo.end(); it++)
		{
			if (_tcsicmp(it->strWinText.c_str(), _T("С")) == 0)
			{
				gbmin = &*it;
			}

			if (_tcsicmp(it->strWinText.c_str(), _T("ˮ")) == 0)
			{
				gp = &*it;
			}

			if (_tcsicmp(it->strWinText.c_str(), _T("Ϸ")) == 0)
			{
				gbentry = &*it;
			}
		}

		if (gp && gbentry && gbmin)
		{
			//::SendMessage(gp->hwnd, WM_LBUTTONDOWN, (WPARAM)gb->dwId, 0);
			//::SendMessage(gp->hwnd, WM_LBUTTONUP, (WPARAM)gb->dwId, 0);
			// ͵¼;
			// С;
			::SendMessage(gp->hwnd, WM_COMMAND, gbmin->dwId, NULL);
			// ٽ;
			::SendMessage(gp->hwnd, WM_COMMAND, gbentry->dwId, NULL);


			Sleep(1500);
			dwPID = GameAssist::GetProcessId();
			if (dwPID)
			{
				GameAssist::g_vtCtrlInfo.clear();
				EnumWindows(GameAssist::EnumChildWindowCallBack, dwPID);
				HWND hwnd = GameAssist::GetProcessMainWnd(dwPID);
				if (hwnd)
				{
					TCHAR szName[MAX_PATH] = { 0 };
					::GetWindowText(hwnd, szName, MAX_PATH);
					CRect rc;
					::GetWindowRect(hwnd, &rc);
					TCHAR szLogMsg[MAX_PATH] = { 0 };
					_stprintf_s(szLogMsg, _T("ڱ⣺%s, [%d,%d, %d,%d], width=%d, height=%d\n"), szName, rc.top, rc.left, rc.right, rc.bottom, rc.Width(), rc.Height());
					OutputDebugString(szLogMsg);
					if (1)
					{ // 800x600
						// ͰťϢ;Ϸ;
						GameAssist::MouseClick({ 585, 116 });
						// ͰťϢ;һ;
						GameAssist::MouseClick({ 536, 481 });
						// ͰťϢ;һ;
						GameAssist::MouseClick({ 229, 342 });
						// ͰťϢ;ǹ;
						GameAssist::MouseClick({ 335, 244 });
						// ͰťϢ;һ;
						GameAssist::MouseClick({ 559, 516 });
					}
					else
					{
						// 640x480
						// ͰťϢ;Ϸ;
						GameAssist::MouseClick({ 440, 75 });
						// ͰťϢ;һ;
						GameAssist::MouseClick({ 468, 454 });
						// ͰťϢ;һ;
						GameAssist::MouseClick({ 165, 241 });
						// ͰťϢ;ǹ;
						GameAssist::MouseClick({ 289, 195 });
						// ͰťϢ;һ;
						GameAssist::MouseClick({ 494, 469 });
					}
				}
			}
		}
	}
#endif
}


void CGameAssistDlg::OnBnClickedButton2()  // ͼ;
{
	HWND hWnd = GetCurGameWnd();
	if (hWnd == NULL)
		return;
	UpdateData();
	INT nX = GetDlgItemInt(IDC_EDIT3);
	INT nY = GetDlgItemInt(IDC_EDIT4);
	INT nX2 = GetDlgItemInt(IDC_EDIT5);
	INT nY2 = GetDlgItemInt(IDC_EDIT6);
	BOOL bCropPicture = ((CButton*)GetDlgItem(IDC_CHECK5))->GetCheck();

	if (bCropPicture)
	{
		std::string strImg = GameGlobal::g_szTempDir;
		strImg.append(_T("ü.bmp"));
		ImgAssist::CropPicture(hWnd, { nX, nY, nX2, nY2 }, strImg.c_str());
	}
	else
	{
		std::string strImg = GameGlobal::g_szTempDir;
		strImg.append(_T("ͼ.bmp"));
		cv::Mat srcImg = ImgAssist::CaptureWnd(hWnd);
		cv::imwrite(strImg.c_str(), srcImg);
	}
}


void CGameAssistDlg::OnBnClickedButton3() // ;
{
	UpdateData();
	/*
	-- Ƿ
	-- Ƿƶ
		|-- Ұץ
		|-- -- Ƿƶ
		|		|-- ȥ
		|		|	|-- ѡ˾
		|		|	|-- Ҿѡ
		|		|-- ǣֱӽƶ
		|-- ǣҵNPC
		|		|-- ץ
		|		|
		|		|
		|
		|
	*/
	int nZJType = 0;
	if (m_cbZJ.GetCheck() || m_cbZJ2.GetCheck())
	{
		if (m_cbZJ.GetCheck())
			nZJType = 1;
		if (m_cbZJ2.GetCheck())
			nZJType = 2;
	}

	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		pAction->m_bHasSummoner = m_cbSummoner.GetCheck();
		pAction->m_nSummonerSkillType = nZJType;
		pAction->m_bTargetOfRoleSkill = m_cbAggressiveSkill.GetCheck();
		pAction->StartBattleJY();
	}
}


void CGameAssistDlg::OnBnClickedButton4() // 
{
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		pAction->GetSaturdayPresents();
	}
}


void CGameAssistDlg::OnBnClickedButton5() // ;
{
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		pAction->OpenChest(20);
	}
}

const char g_szHeros[12][10] = { "ҽʦ","ʿ","ʿ","ʦ","Ӷ","Ͷ","ֶ","","ī߶","ɷ","","Ƕ" };
void CGameAssistDlg::OnBnClickedButton6() // ְҵս;
{
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		if (!pAction->FindNPCByWorldMap("ְҵѵʦ"))
			return;
		// ѡ;
		BOOL bMatch = FALSE;
		int trySize = 20;

		// Ҫս;
		while (!(bMatch = pAction->ClickDlgSetup(_T("img\\zyxdds-wytztm.bmp")))) {
			SRAND(1200, 2200);
			if (!trySize--) break;
		}

		// ׼
		if (pAction->ClickDlgSetup(_T("img\\zyxdds-zbhl.bmp")))
		{
			// ͼлȳͼ;
			SRAND(2000, 2500);
			if (pAction->IsOnMap(_T("img\\gdd\\name.bmp")))
			{
				pAction->FightingYS("");
				for (int i = 1; i < 12; i++)
				{
					pAction->FightingOthers(g_szHeros[i], "");
				}
			}
		}
	}
}

void CGameAssistDlg::OnBnClickedButton7()	// ԰;
{
	// TODO: ڴӿؼ֪ͨ
}

void CGameAssistDlg::OnBnClickedButton8() // ְҵս2;
{
	CComboBox* pList = (CComboBox*)GetDlgItem(CB_HERO);
	int nIndex = pList->GetCurSel();
	if (nIndex == CB_ERR)
		return;
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		for (int i = nIndex; i < 12; i++)
		{
			//SRAND(250, 350);
			//pAction->SendKey(VK_A, FALSE, TRUE);
			if (pAction->IsSPBelowSafeValue(TRUE, TRUE, 30))
			{
				DebugLog(_T("SPȫֵ"));
				// Ҽ;
				pAction->MouseMove({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2, (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2 });
				pAction->MouseRClick({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2, (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2 });
			}

			pAction->FightingOthers(g_szHeros[i], "");
		}
	}
}

void CGameAssistDlg::OnBnClickedButton9() // ƶĿ
{
	UpdateData();
	INT nX = GetDlgItemInt(IDC_EDIT1);
	INT nY = GetDlgItemInt(IDC_EDIT2);
	BOOL bOpenMap = ((CButton*)GetDlgItem(IDC_CHECK4))->GetCheck();
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		if (bOpenMap)
			pAction->WorldMapPositioning({ nX, nY });
		else
			pAction->MouseMove({ nX, nY });
	}
}


void CGameAssistDlg::OnBnClickedButton10() // Alt+A
{
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		pAction->StartRepeat();
	}
}

void CGameAssistDlg::OnBnClickedButton11() // ˢ;
{
	std::vector<DWORD> vtPID;
	GameAssist::GetAllProcessId(vtPID);
	GameAssist::GetAllProcessMainWnd(vtPID, GameAssist::g_vtGameWndInfo);

	int nIndx = 0;
	m_cbGameRole.ResetContent();
	for (std::vector<GameAssist::GameWndInfo>::iterator it = GameAssist::g_vtGameWndInfo.begin(); it != GameAssist::g_vtGameWndInfo.end(); it++)
	{
		if (it->strGameRoleName.size() == 0)
			continue;
		if (it->pAction == NULL)
			it->pAction = new GameAssist::CAction(it->hWnd);
		nIndx = m_cbGameRole.AddString(it->strGameRoleName.c_str());
		m_cbGameRole.SetItemDataPtr(nIndx, &*it);
	}
	m_cbGameRole.SetCurSel(0);
}


void CGameAssistDlg::OnBnClickedButton12() // Ұ;
{
	std::map<std::string, int> SkillMap = {
		{"F1",VK_F1},
		{"F2",VK_F2},
		{"F3",VK_F3},
		{"F4",VK_F4},
		{"F5",VK_F5},
		{"F6",VK_F6},
		{"F7",VK_F7},
		{"F8",VK_F8},
	};

	BOOL bCheckAttack = ((CButton*)GetDlgItem(IDC_CHECK_ATTACK))->GetCheck();
	CString strSkill;
	int nCurSel = m_cb_skill_list.GetCurSel();
	if (nCurSel == CB_ERR)
		return;

	m_cb_skill_list.GetLBText(nCurSel, strSkill);

	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		pAction->m_nSkillShortcutKey = SkillMap.find(strSkill.GetString())->second;
		pAction->m_bTargetOfRoleSkill = bCheckAttack;
		pAction->StartSkill();
	}
}

void CGameAssistDlg::OnBnClickedButton13() // ͼսNPC;
{
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;
		int nCurSel = m_cbZYNPC.GetCurSel();
		if (nCurSel == CB_ERR)
			return;

		CString strNPC;
		m_cbZYNPC.GetLBText(nCurSel, strNPC);
		auto it = GameAssist::g_mapZYNPC.find(strNPC.GetString());
		if (it != GameAssist::g_mapZYNPC.end())
		{
			pAction->WorldMapPositioning({ it->second.x, it->second.y });
		}
	}
}


void CGameAssistDlg::OnBnClickedButton14()
{
	GameAssist::GameWndInfo* pGameInfo = GetCurGameInfo();
	if (pGameInfo && pGameInfo->pAction)
	{
		GameAssist::CAction* pAction = (GameAssist::CAction*)pGameInfo->pAction;

		CRect rc = pAction->FindMatchIcon(_T(".\\img\\ӻ.bmp"));
		if (rc.IsRectEmpty() || rc.IsRectNull())
		{
			MessageBox(_T("δҵӻť"));
			return;
		}

		INT X = (rc.right + rc.left) / 2;
		INT Y = (rc.top + rc.bottom) / 2;
		INT nCount = GetDlgItemInt(IDC_EDIT7);
		if (pAction)
		{
			pAction->MouseMove({ X,Y });
			for (size_t i = 0; i < nCount; i++)
			{
				pAction->MouseClick();
				SRAND(850, 1050);
				SetDlgItemInt(IDC_EDIT7, nCount - i);
			}
		}
	}
}
