#pragma once

namespace ImgAssist 
{
	std::string CaptureGameWnd(HWND hWnd);
	void CaptureGameWnd(HWND hWnd, std::string strSavePath);
	cv::Mat CaptureWnd(HWND hWnd);
	BOOL OpenImage(std::string strImag, cv::Mat& img);
	cv::Mat OpenImage(std::string strImage);
	BOOL SetImgThreshold(cv::Mat& srcImg, cv::Mat& thresholdImg, long nThresholdVal, long nMaxThresholdVal, int type = 0);
	BOOL GetImgMatchtemplate(HWND hWnd, cv::Mat cvTempImg, RECT& rc, double lowestMatchValue = 0.900);
	BOOL GetImgMatchtemplate(cv::Mat cvSrcImg, cv::Mat cvTempImg, RECT& rc, double lowestMatchValue = 0.900);
	BOOL GetImgMatchtemplate(HWND hWnd, std::string strTempImg, RECT& rc, double lowestMatchValue = 0.900);
	BOOL GetImgMatchtemplate(std::string strSrcImg, std::string strTempImg, RECT& rc, double lowestMatchValue = 0.900);
	BOOL IsMatchIcon(cv::Mat cvSrcImg, cv::Mat cvTempImg, RECT srcRect, RECT& matchRect, double lowestMatchValue = 0.900);
	BOOL IsMatchIcon(HWND hWnd, std::string strTempImg, RECT srcRect, RECT& matchRect, double lowestMatchValue = 0.900);
	BOOL CropPicture(HWND hWnd, CRect rc, const char* szSaveName); // ͼƬ;
	cv::Mat CropPicture(HWND hWnd, CRect rc);
	BOOL IsSimilarPicture(const char* szp1, const char* szp2, double lowestMatchValue = 0.99);
	BOOL IsSimilarPicture(cv::Mat src1, cv::Mat src2, double lowestMatchValue = 0.99);
	// ȡָɫռþγȱ;
	int GetColorOccupiedLength(std::string strImg, int r, int g, int b);
	int GetColorOccupiedLength(cv::Mat src, int r, int g, int b);
};
