#include "StdAfx.h"
#include "PipeService.h"
//#include "MainDlg.h"

#define PIPENAME _T("\\\\.\\pipe\\Assist")
// ÿһϲٸ߳(Ϊ޶ȵܣĵ)
#define WORKER_THREADS_PER_PROCESSOR 2
// ͬʱͶݵAccept(Ҫʵʵ)
#define MAX_POST_ACCEPT              10
// ݸWorker̵߳˳ź
#define EXIT_CODE                    NULL


// ͷָ;Դĺ

// ͷָ
#define RELEASE(x)                      {if(x != NULL ){delete x;x=NULL;}}
// ͷž
#define RELEASE_HANDLE(x)               {if(x != NULL && x!=INVALID_HANDLE_VALUE){ CloseHandle(x);x = NULL;}}
// ͷSocket
#define RELEASE_SOCKET(x)               {if(x !=INVALID_SOCKET) { closesocket(x);x=INVALID_SOCKET;}}


CIOCPPipe::CIOCPPipe(void)
{
    m_nThreads = 0;
    m_hShutdownEvent = NULL;
    m_hIOCompletionPort = NULL;
    m_phWorkerThreads= NULL;
    m_pMain = NULL;
}

CIOCPPipe::~CIOCPPipe(void)
{
	// ȷԴͷ
	this->Stop();
}

DWORD WINAPI CIOCPPipe::_WorkerThread(LPVOID lpParam)
{    
	THREADPARAMS_WORKER* pParam = (THREADPARAMS_WORKER*)lpParam;
	CIOCPPipe* pIOCPModel = (CIOCPPipe*)pParam->pIOCPModel;
	int nThreadNo = (int)pParam->nThreadNo;

	pIOCPModel->_ShowMessage(_T("߳ID: %d."),nThreadNo);

	OVERLAPPED           *pOverlapped = NULL;
	ULONG_PTR            pCompletionKey  = NULL;
	DWORD                dwBytesTransfered = 0;

	// ѭ֪յShutdownϢΪֹ
	while (WAIT_OBJECT_0 != WaitForSingleObject(pIOCPModel->m_hShutdownEvent, 0))
	{
		BOOL bReturn = GetQueuedCompletionStatus(
			pIOCPModel->m_hIOCompletionPort,
			&dwBytesTransfered,
			&pCompletionKey,
			&pOverlapped,
			INFINITE);

        dprintf(_T("IOCPϢ"));

		// յ˳־ֱ˳
		if ( EXIT_CODE==(DWORD)pCompletionKey )
		{
			//break;
            continue;
		}

		// жǷ˴
		if( !bReturn )  
		{  
			DWORD dwErr = GetLastError();

			// ʾһʾϢ
            // ȡĲ
            PER_IO_CONTEXT* pIoContext = CONTAINING_RECORD(pOverlapped, PER_IO_CONTEXT, m_Overlapped);  
			if( !pIOCPModel->HandleError( pIoContext,dwErr ) )
			{
				//break;
                continue;
			}

			continue;  
		}  
		else  
		{  	
			// ȡĲ
			PER_IO_CONTEXT* pIoContext = CONTAINING_RECORD(pOverlapped, PER_IO_CONTEXT, m_Overlapped);  

			// жǷпͻ˶Ͽ
			if((0 == dwBytesTransfered) && ( OP_RECV==pIoContext->m_OpType || OP_SEND==pIoContext->m_OpType))  
			{  
				pIOCPModel->_ShowMessage( _T("ͻ %s:%d Ͽ."),pIoContext->chClientName, pIoContext->dwProcessId );

				// ͷŵӦԴ
				pIOCPModel->_RemoveContext( pIoContext );

 				continue;  
			}  
			else
			{
				switch( pIoContext->m_OpType )  
				{  
				case OP_ACCEPT:
					{ 
						pIOCPModel->_DoAccpet( pIoContext );
                        dprintf(_T("ͻӳɹ"));
					}
					break;
				case OP_RECV:
					{
						//pIOCPModel->_DoRecv( pSocketContext,pIoContext );
					}
					break;
				case OP_SEND:
					break;
				default:
					// Ӧִе
					TRACE(_T("_WorkThreadе pIoContext->m_OpType 쳣.\n"));
					break;
				}
			}
		}
	}

	TRACE(_T("߳ %d ˳.\n"),nThreadNo);

	// ͷ̲߳
	RELEASE(lpParam);	

	return 0;
}

bool CIOCPPipe::Start()
{
	// ʼ̻߳
	InitializeCriticalSection(&m_csContextList);

	// ϵͳ˳¼֪ͨ
	m_hShutdownEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	// ʼIOCP
	if (false == _InitializeIOCP())
	{
		this->_ShowMessage(_T("ʼIOCPʧܣ\n"));
		return false;
	}
	else
	{
		this->_ShowMessage(_T("\nIOCPʼ\n."));
	}


	this->_ShowMessage(_T("ϵͳ׼Ⱥ....\n"));

	return true;
}

void CIOCPPipe::Stop()
{
    // رϢ֪ͨ
    SetEvent(m_hShutdownEvent);

    for (int i = 0; i < m_nThreads; i++)
    {
        // ֪ͨеɶ˿ڲ˳
        PostQueuedCompletionStatus(m_hIOCompletionPort, 0, (DWORD)EXIT_CODE, NULL);
    }

    // ȴеĿͻԴ˳
    WaitForMultipleObjects(m_nThreads, m_phWorkerThreads, TRUE, INFINITE);

    // ͻбϢ
    this->_ClearContextList();

    // ͷԴ
    this->_DeInitialize();

    this->_ShowMessage(_T("ֹͣ\n"));
}

bool CIOCPPipe::_InitializeIOCP()
{
	// һɶ˿
	m_hIOCompletionPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0 );

	if ( NULL == m_hIOCompletionPort)
	{
		this->_ShowMessage(_T("ɶ˿ʧܣ: %d!\n"), WSAGetLastError());
		return false;
	}

	// ݱеĴӦ߳
#ifdef _DEBUG
    m_nThreads = 1;
#else
	m_nThreads = WORKER_THREADS_PER_PROCESSOR * _GetNoOfProcessors();
#endif

	// Ϊ̳߳ʼ
	m_phWorkerThreads = new HANDLE[m_nThreads];
	
	// ݼ߳
	DWORD nThreadID;
	for (int i = 0; i < m_nThreads; i++)
	{
		THREADPARAMS_WORKER* pThreadParams = new THREADPARAMS_WORKER;
		pThreadParams->pIOCPModel = this;
		pThreadParams->nThreadNo  = i+1;
		m_phWorkerThreads[i] = ::CreateThread(0, 0, _WorkerThread, (void *)pThreadParams, 0, &nThreadID);
	}

    _PostAccept();
	TRACE("  _WorkerThread %d .\n", m_nThreads );

	return true;
}

void CIOCPPipe::_DeInitialize()
{
	// ɾͻбĻ
	DeleteCriticalSection(&m_csContextList);

	// رϵͳ˳¼
	RELEASE_HANDLE(m_hShutdownEvent);

	// ͷŹָ߳̾
	for( int i=0;i<m_nThreads;i++ )
	{
		RELEASE_HANDLE(m_phWorkerThreads[i]);
	}
	
	RELEASE(m_phWorkerThreads);

	// رIOCP
	RELEASE_HANDLE(m_hIOCompletionPort);

	_ShowMessage(_T("ͷԴ.\n"));
}

bool CIOCPPipe::_PostAccept()
{
    HANDLE hPipeAccept = CreateNamedPipe(
        PIPENAME,                // pipe name 
        PIPE_ACCESS_DUPLEX |     // read/write access 
        FILE_FLAG_OVERLAPPED,    // overlapped mode 
        PIPE_TYPE_MESSAGE |      // message-type pipe 
        PIPE_READMODE_MESSAGE |  // message-read mode 
        PIPE_WAIT,               // blocking mode 
        PIPE_UNLIMITED_INSTANCES,               // number of instances 
        0,   // output buffer size 
        0,   // input buffer size 
        NMPWAIT_WAIT_FOREVER,     // client time-out 
        NULL);                   // default security attributes

    if ( hPipeAccept == INVALID_HANDLE_VALUE )
        return false;

    HANDLE hIOCP = CreateIoCompletionPort(hPipeAccept, m_hIOCompletionPort, 10001, 0);
    if ( hIOCP == NULL )
    {
        CloseHandle(hPipeAccept);
        return false;
    }

    PER_IO_CONTEXT *pMyOverlapped = new PER_IO_CONTEXT;
    memset(pMyOverlapped, 0, sizeof(PER_IO_CONTEXT));
    pMyOverlapped->m_OpType = OP_ACCEPT;
    pMyOverlapped->m_PipeAccept = hPipeAccept;
    BOOL bRet = ConnectNamedPipe(hPipeAccept, (LPOVERLAPPED)pMyOverlapped);

	if( bRet )  
	{// صIOɶ˿,صFase;
        CloseHandle(hPipeAccept);
        CloseHandle(hIOCP);
        delete pMyOverlapped;
        pMyOverlapped = NULL;
		_ShowMessage(_T("AcceptPipeʧܣ: %d"), GetLastError()); 
		return false;  
	} 

	return true;
}

bool CIOCPPipe::_DoAccpet( PER_IO_CONTEXT* pIoContext )
{
	// ͻӺ,ָȡͻעϢ;
    pIoContext->m_OpType = OP_SEND;
    _stprintf_s(pIoContext->chReply, _T("%s"), _T("1001"));
    pIoContext->cbToWrite = _tcslen(pIoContext->chReply);
	
    DWORD dwNumberOfBytesWritten = 0;
    BOOL fWrite = WriteFile(
        pIoContext->m_PipeAccept,
        pIoContext->chReply,
        pIoContext->cbToWrite,
        &dwNumberOfBytesWritten,
        (LPOVERLAPPED)pIoContext);
    
    if (!fWrite) {
        dprintf("WriteFie: dwWritten=%d,GLE=%d\n", pIoContext->cbToWrite, GetLastError());
    }

    dprintf(_T("ͻ˷Ϣ"));

	////////////////////////////////////////////////////////////////////////////////////////////////
	// 5. ʹ֮󣬰Listen SocketǸIoContextãȻ׼ͶµAcceptEx
	pIoContext->ResetBuffer();
	return this->_PostAccept( ); 	
}

bool CIOCPPipe::_PostRecv( PER_IO_CONTEXT* pIoContext )
{
	// ʼ
	DWORD dwFlags = 0;
	DWORD dwBytes = 0;
	OVERLAPPED *p_ol = &pIoContext->m_Overlapped;

	pIoContext->ResetBuffer();
	pIoContext->m_OpType = OP_RECV;

	return true;
}

bool CIOCPPipe::_DoRecv(  PER_IO_CONTEXT* pIoContext )
{
	// Ȱһεʾ֣Ȼ״̬һRecv


	// ȻʼͶһWSARecv
	return _PostRecv( pIoContext );
}

bool CIOCPPipe::_AssociateWithIOCP( PER_IO_CONTEXT* pIoContext )
{
	// ںͿͻͨŵSOCKET󶨵ɶ˿
	
	return true;
}

void CIOCPPipe::_AddToContextList( PER_IO_CONTEXT* pIoContext )
{
	EnterCriticalSection(&m_csContextList);

	//m_arrayClientContext.Add(pHandleData);	
	
	LeaveCriticalSection(&m_csContextList);
}

void CIOCPPipe::_RemoveContext( PER_IO_CONTEXT* pIoContext )
{
	EnterCriticalSection(&m_csContextList);

	

	LeaveCriticalSection(&m_csContextList);
}

void CIOCPPipe::_ClearContextList()
{
	EnterCriticalSection(&m_csContextList);

	for( int i=0;i<m_arrayClientContext.GetCount();i++ )
	{
		delete m_arrayClientContext.GetAt(i);
	}

	m_arrayClientContext.RemoveAll();

	LeaveCriticalSection(&m_csContextList);
}

int CIOCPPipe::_GetNoOfProcessors()
{
	SYSTEM_INFO si;

	GetSystemInfo(&si);

	return si.dwNumberOfProcessors;
}

void CIOCPPipe::_ShowMessage(const CString szFormat,...) const
{
	// ݴĲʽַ
	CString   strMessage;
	va_list   arglist;

	// 䳤
	va_start(arglist, szFormat);
	strMessage.FormatV(szFormat,arglist);
	va_end(arglist);

}

/////////////////////////////////////////////////////////////////////
// жϿͻSocketǷѾϿһЧSocketͶWSARecv쳣
// ʹõķǳsocketݣжsocketõķֵ
// Ϊͻ쳣Ͽ(ͻ˱߰εߵ)ʱ򣬷޷յͻ˶Ͽ֪ͨ

bool CIOCPPipe::_IsSocketAlive(SOCKET s)
{
	int nByteSent=send(s,"",0,0);
	if (-1 == nByteSent) return false;
	return true;
}

bool CIOCPPipe::HandleError( PER_IO_CONTEXT *pIoContext,const DWORD& dwErr )
{
	// ǳʱˣټȰ  
	if(WAIT_TIMEOUT == dwErr)  
	{  	

	}  

	// ǿͻ쳣˳
	else if( ERROR_NETNAME_DELETED==dwErr )
	{
		this->_ShowMessage( _T("⵽ͻ쳣˳") );
		return true;
	}

	else
	{
		this->_ShowMessage( _T("ɶ˿ڲִ߳˳룺%d"),dwErr );
		return false;
	}
}




