#include "stdafx.h"
#include "CAction.h"
#include "tinyxml2.h"

namespace GameAssist
{
#define SETGAMEFOREGROUND AutoThreadSection ats(&m_ts);\
if (!::IsWindow(m_hGameWnd)) return;\
::ShowWindow(m_hGameWnd, SW_SHOWNORMAL);\
::SetForegroundWindow(m_hGameWnd);\
SRAND(80,120);

#define SETGAMEFOREGROUND2 AutoThreadSection ats(&m_ts);\
if (!::IsWindow(m_hGameWnd)) return;\
::ShowWindow(m_hGameWnd, SW_SHOWNORMAL);\
::SetForegroundWindow(m_hGameWnd);\
SRAND(30,50);

	std::map<std::string, POINT> g_mapZYNPC;
	std::map<std::string, PNPC> g_mapZYNPC2;
	std::map<std::string, METAGRAPH> g_mapMetaGraph;

	// ʹÿݼȡļ
	auto FindJNShortCut = [](LPCTSTR lpSkillName, int& nKeyValue, int& nSkilltime)->BOOL {
		// ȡļjnmap.bin
		// ʽ=ݼļֵ;
		std::string line;
		std::ifstream ifJN("img\\jnmap.bin");
		if (ifJN)
		{
			TCHAR szKeyValue[MAX_PATH] = { 0 };
			TCHAR szSkillName[MAX_PATH] = { 0 };
			TCHAR szSkillTime[MAX_PATH] = { 0 };
			while (std::getline(ifJN, line))
			{
				int nRet = _stscanf_s(line.c_str(), _T("%[^;];%[^;];%s"), szSkillName, MAX_PATH, szKeyValue, MAX_PATH, szSkillTime, MAX_PATH);
				if (nRet == 3 && _tcsicmp(lpSkillName, szSkillName) == 0) {
					// ݼֵ
					nKeyValue = atol(szKeyValue);
					nSkilltime = atol(szSkillTime);
					return TRUE;
				}
			}
		}

		// ûҵjnmap.binļ;
		return FALSE;
	};


	ThreadSection CAction::m_ts;
	CAction::CAction(HWND hWnd) :m_hGameWnd(hWnd), m_ptCur({ 0,0 })
	{
		m_hBattleJY = NULL;
		m_hBattleJYEvent = NULL;
		m_hBattleZYTZ = NULL;
		m_nSkillShortcutKey = VK_F1;
		InitNPCInfo();
	}

	CAction::~CAction()
	{
	}

	void CAction::MouseMove(POINT pt, bool bSetCurPos)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, pt);
		GameAssist::MouseMove(pt, bSetCurPos);
		SRAND(80, 150);
	}

	void CAction::MouseMove(POINT ptStart, POINT ptEnd, bool bSetCurPos)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, ptStart);
		GameAssist::MouseMove(ptStart, bSetCurPos);
		Sleep(50);
		GameAssist::GamePos2Screen(m_hGameWnd, ptEnd);
		GameAssist::MouseMove(ptEnd, bSetCurPos);
		SRAND(80, 150);
	}

	void CAction::MouseMoveEx(POINT pt, bool bSetCurPos)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, pt);
		GameAssist::MouseClick(pt);
		SRAND(80, 150);
	}

	void CAction::MouseMoveEx(POINT ptStart, POINT ptEnd, bool bSetCurPos)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, ptStart);
		GameAssist::MouseMove(ptStart, bSetCurPos);

		GameAssist::GamePos2Screen(m_hGameWnd, ptEnd);
		GameAssist::MouseClick(ptEnd);
		SRAND(80, 150);
	}

	void CAction::MouseClick()
	{
		SETGAMEFOREGROUND;
		GameAssist::MouseClick();
		SRAND(80, 150);
	}

	void CAction::MouseClick(POINT pt)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, pt);
		GameAssist::MouseClick(pt);
		SRAND(80, 150);
	}

	void CAction::MouseDbClick()
	{
		SETGAMEFOREGROUND;
		GameAssist::MouseDbClick();
		SRAND(80, 150);
	}

	void CAction::MouseDbClick(POINT pt)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, pt);
		GameAssist::MouseDbClick(pt);
		SRAND(80, 150);
	}

	void CAction::MouseRClick()
	{
		SETGAMEFOREGROUND;
		GameAssist::MouseRClick();
		SRAND(80, 150);
	}

	void CAction::MouseRClick(POINT pt)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, pt);
		GameAssist::MouseRClick(pt);
		SRAND(80, 150);
	}

	void CAction::MouseDrag(POINT pt)
	{
		SETGAMEFOREGROUND;
		GameAssist::GamePos2Screen(m_hGameWnd, pt);
		GameAssist::MouseDrag(pt);
		SRAND(80, 150);
	}

	void CAction::SendKey(DWORD key, BOOL bCtrl, BOOL bAtl, BOOL bShift)
	{
		SETGAMEFOREGROUND;
		GameAssist::SendKey(key, bCtrl, bAtl, bShift);
		SRAND(80, 150);
	}

	void CAction::SendKeyFast(DWORD key, BOOL bCtrl, BOOL bAtl, BOOL bShift)
	{
		SETGAMEFOREGROUND2;
		GameAssist::SendKeyFast(key, bCtrl, bAtl, bShift);
	}

	void CAction::InitNPCInfo()
	{
		static bool bInit = false;
		if (!bInit) {
			// "ҽʦ","ʿ","ʿ","ʦ","Ӷ","Ͷ", "ֶ", "", "ī߶", "ɷ", ""
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ҽʦ"), { 305, 325 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ʿ"), { 305, 325 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ʿ"), { 305, 325 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ʦ"), { 305, 325 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("Ӷ"), { 160, 435 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("Ͷ"), { 420, 215 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ֶ"), { 265, 240 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T(""), { 155, 205 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ī߶"), { 155, 205 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ɷ"), { 155, 205 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T(""), { 165, 335 }));
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("Ƕ"), { 440, 324 }));
			// Ӧ츮NPC
			g_mapZYNPC.insert(std::pair<std::string, POINT>(_T("ְҵѵʦ"), { 315, 415 }));

			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("ҽʦ"), { { 305, 325 }, { 590, 380 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("ʿ"), { { 305, 325 }, { 610, 160 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("ʿ"), { { 305, 325 }, { 140, 160 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("ʦ"), { { 305, 325 }, { 140, 380 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("Ӷ"), { { 160, 435 }, { 190, 370 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("Ͷ"), { { 420, 215 }, { 540, 170 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("ֶ"), { { 265, 240 }, { 465, 120 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T(""), { { 155, 205 }, { 605, 235 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("ī߶"), { { 155, 205 }, { 315, 380 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("ɷ"), { { 155, 205 }, { 270, 175 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T(""), { { 165, 335 }, { 270, 305 } }));
			g_mapZYNPC2.insert(std::pair<std::string, PNPC>(_T("Ƕ"), { { 440, 324 }, { 571, 219 } }));

			bInit = true;
		}
	}

	void CAction::SetGameForeground()
	{
		AutoThreadSection ats(&m_ts);
		if (!::IsWindow(m_hGameWnd)) return;
		::ShowWindow(m_hGameWnd, SW_SHOWNORMAL);
		::SetForegroundWindow(m_hGameWnd); // ǰòܵɹ;
	}

	bool CAction::IsWalkStop()
	{
		if (!::IsWindow(m_hGameWnd))
			return false;

		// ,Ҫڿͼ;
		// ͼ,ָ;
		// ٽͼ,ָϴοͼȽ;
		// ȽϽͬʾֹͣ·;
		//POINT pt1 = { 635, 20 }; 
		//POINT pt2 = { 780, 38 };
		CRect rc = { 630, 40, 800, 65 };
		CRect rc2 = { 640, 45, 770, 63 };
		for (int i = 0; i < 100; i++)
		{
			cv::Mat src1 = ImgAssist::CropPicture(m_hGameWnd, rc);
			Sleep(600);
			cv::Mat src2 = ImgAssist::CropPicture(m_hGameWnd, rc2);
			// ж2ͼƬǷһ;
			if (ImgAssist::IsSimilarPicture(src1, src2))
			{
				GameGlobal::DebugLog(_T("ֹͣ·"));
				return true;
			}
		}

		return false;
	}

	bool CAction::IsFighting()
	{
		CRect rc;
		SRAND(100, 200);
		if (ImgAssist::IsMatchIcon(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\\\\\ս.bmp"), { 600, 0, 800, 60 }, rc)) {
			GameGlobal::DebugLog(_T("Battleս"));
			return false;
		}

		GameGlobal::DebugLog(_T("Battleս"));
		return true;
	}

	CRect CAction::FindMatchIcon(LPCTSTR lpszTemplateImage)
	{
		CRect rc;
		TCHAR szTemplateImage[MAX_PATH] = { 0 };
		// Ƚͼ;
		GameGlobal::DebugLog(_T("FindMatchIcon=%s"), lpszTemplateImage);
		_stprintf_s(szTemplateImage, _T("%s%s"), GameGlobal::g_strAppdir.c_str(), lpszTemplateImage);
		if (ImgAssist::GetImgMatchtemplate(m_hGameWnd, szTemplateImage, rc)) {
			// ҵƥģ;
			GameGlobal::DebugLog(_T("====> ҵƥĿ:%s"), lpszTemplateImage);
			return rc;
		}

		rc.SetRectEmpty();
		GameGlobal::DebugLog(_T("<==== ûҵƥĿ:%s"), lpszTemplateImage);
		return rc;
	}

	bool CAction::IsOnMap(LPCTSTR lpszTemplateImage)
	{
		CRect rc = FindMatchIcon(lpszTemplateImage);
		if (rc.IsRectEmpty() || rc.IsRectNull())
			return false;

		return true;
	}

	void CAction::WorldMapPositioning(POINT ptMap)
	{
		CRect rc;
		//// ͼ;
		SendKey(VK_TAB); SRAND(550, 800);
		// жǷ˵ͼ;
		if (!ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\ͼ.bmp"), rc))
			return;

		//// Ѱ·;
		MouseClick(ptMap); SRAND(300, 600);

		while (ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\ͼ.bmp"), rc)) {
			// ˳ַ;
			SendKey(VK_TAB); SRAND(200, 300);
		}

		IsWalkStop();
	}

	bool CAction::IsWattingAttack(int nAttackNPCType)
	{
		CRect rc;
		BOOL bIsAttack = FALSE;
		if (ImgAssist::IsMatchIcon(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\ҷ2.bmp"), { 700, 50, 800, 120 }, rc)) {
			GameGlobal::DebugLog(_T("IsWattingAttackҷС"));
			bIsAttack = TRUE;
		}

		return bIsAttack;
	}

	bool CAction::ClickDlgSetup(LPCSTR lpszTemplateImage)
	{
		CRect rc = FindMatchIcon(_T("img\\Իرհť.bmp"));
		if (rc.IsRectEmpty() || rc.IsRectNull())
			return false;

		// ƶرհť;
		MouseMove({ rc.left - 30 , rc.top + 10 });
		SRAND(50, 80);
		// Ŀ;
		rc = FindMatchIcon(lpszTemplateImage);
		SRAND(50, 80);
		// Ŀ;
		MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2 + rand() % 3));
		// ϵͳͼҪʱȽϳ;
		SRAND(100, 200);
		// ĿҪֹ꣬ƥʱ굲ס;
		MouseMove(CPoint(rc.top - RAND(5, 12), rc.left - RAND(5, 10))); // ƶϽ;
		SRAND(100, 200);

		return true;
	}

	bool CAction::ClickDlgSetup(std::vector<std::string> vtOptions)
	{
		std::vector<std::string>::iterator it = vtOptions.begin();
		for (; it != vtOptions.end(); it++)
		{

		}

		return false;
	}

	bool CAction::FindNPCByWorldMap(LPCTSTR lpszNPCName)
	{
		CRect rc;
		//// ͼ;
		SendKey(VK_TAB); SRAND(500, 600);
		if (!ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\Ѱ·.bmp"), rc))
			return false;

		//// Ѱ·;
		MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 2, (rc.top + rc.bottom) / 2 + rand() % 2)); SRAND(500, 800);
		//// üа壺ְҵս;
		SetClipboardString(lpszNPCName); SRAND(200, 500);
		//// Ctrl+V
		SendKey(0x56, TRUE); SRAND(300, 500);
		// ƶĿ󣬲ʵֵ;
		MouseMove(CPoint((rc.right + rc.left) / 2 + 5 + rand() % 2, (rc.top + rc.bottom) / 2 + 60 + rand() % 2)); SRAND(200, 300);
		//// Ѱ·50Ŀ;
		MouseDbClick(CPoint((rc.right + rc.left) / 2 + 5 + rand() % 2, (rc.top + rc.bottom) / 2 + 60 + rand() % 2)); SRAND(200, 300);
		while (ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\ͼ.bmp"), rc)) {
			// ˳ַ;
			SendKey(VK_TAB); SRAND(200, 300);
		}

		// ֱֹͣ߶Ϊֹ;
		IsWalkStop();

		// 3;
		bool bFind = false;
		for (int i = 0; i < 3; i++)
		{
			Sleep(800 - i * 150);
			rc = FindMatchIcon(_T("img\\Իرհť.bmp"));
			if (!rc.IsRectEmpty() && !rc.IsRectNull())
			{
				bFind = true;
				break;
			}
		}

		return bFind;
	}

	bool CAction::FindNPCByIcon(POINT ptMap, LPCTSTR lpszNPCName)
	{
		TCHAR szNPC[MAX_PATH] = { 0 };
		_stprintf_s(szNPC, _T("img\\npc\\%s.bmp"), lpszNPCName);
		CRect rc = FindMatchIcon(szNPC);
		if (rc.IsRectEmpty() || rc.IsRectNull())
		{
			WorldMapPositioning(ptMap);
			Sleep(600); // ʱߵĿ㣬NPCδˢ³;
			rc = FindMatchIcon(szNPC);
			if (rc.IsRectEmpty() || rc.IsRectNull())
			{
				// ܻδˢ³,ٴεȴ;
				Sleep(300);
				rc = FindMatchIcon(szNPC);
				if (rc.IsRectEmpty() || rc.IsRectNull())
				{
					return false;
				}
			}
		}

		// ҵĿ,;
		MouseMove(CPoint(rc.left, rc.top));
		// Ҫս;
		MouseClick({ (rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2 });
		SRAND(500, 1300);// ȶԻ;
		// ƶ꣺Ҫͣ;
		MouseMove({ rc.left - rand() % 10, rc.top - rand() % 10 });

		return true;
	}

	bool CAction::FindNPCByIconAndPos(LPCTSTR lpszNPCName, POINT ptMap, POINT ptNpc)
	{
		TCHAR szNPC[MAX_PATH] = { 0 };
		_stprintf_s(szNPC, _T("img\\npc\\%s.bmp"), lpszNPCName);
		CRect rc = FindMatchIcon(szNPC);
		if (rc.IsRectEmpty() || rc.IsRectNull())
		{
			WorldMapPositioning(ptMap);
			Sleep(600); // ʱߵĿ㣬NPCδˢ³;
			rc = FindMatchIcon(szNPC);
			if (rc.IsRectEmpty() || rc.IsRectNull())
			{
				// ܻδˢ³,ٴεȴ;
				Sleep(600);
				rc = FindMatchIcon(szNPC);
				if (rc.IsRectEmpty() || rc.IsRectNull())
				{
					return false;
				}
			}
		}

		// ҵĿ,;
		MouseMove(CPoint(rc.left - rand() % 30, rc.top + rand() % 50));
		// Ҫս;
		MouseClick(ptNpc);

		// 3;
		bool bFind = false;
		for (int i = 0; i < 3; i++)
		{
			Sleep(800 - i * 150);
			CRect rc = FindMatchIcon("img\\Իرհť.bmp");
			if (!rc.IsRectEmpty() && !rc.IsRectNull())
			{
				bFind = true;
				break;
			}
		}

		// ƶ꣺Ҫͣ;
		MouseMove({ ptNpc.x - rand() % 30, ptNpc.y - rand() % 30 });

		return bFind;
	}

	bool CAction::FindNPCByMap(LPCTSTR lpszNPCName)
	{
		auto it = g_mapZYNPC2.find(lpszNPCName);
		if (it != g_mapZYNPC2.end())
		{
			if (FindNPCByIconAndPos(it->first.c_str(), it->second.ptMap, it->second.ptNpc))
			{
				return true;
			}
		}

		return false;
	}

	bool CAction::IsSPBelowSafeValue(BOOL IsRole, BOOL IsIdle, int nSafeValue /*= 30*/)
	{
		RECT rect = { 0,0,0,0 };
		if (IsIdle)
		{
			rect = IsRole ? GameAssist::g_rcRoleIdleSP : GameAssist::g_rcSummonerIdleSP;
		}
		else
		{
			rect = IsRole ? GameAssist::g_rcRoleFightingSP : GameAssist::g_rcSummonerFightingSP;
		}

		// ͼ;
		return ImgAssist::GetColorOccupiedLength(ImgAssist::CropPicture(m_hGameWnd, rect), 8, 96, 248) < nSafeValue;
	}

	bool CAction::IsHPBelowSafeValue(BOOL IsRole, BOOL IsIdle, int nSafeValue /*= 30*/)
	{
		RECT rect = { 0,0,0,0 };
		if (IsIdle)
		{
			rect = IsRole ? GameAssist::g_rcRoleIdleHP : GameAssist::g_rcSummonerIdleHP;
		}
		else
		{
			rect = IsRole ? GameAssist::g_rcRoleFightingHP : GameAssist::g_rcSummonerFightingHP;
		}

		// ͼ;
		return ImgAssist::GetColorOccupiedLength(ImgAssist::CropPicture(m_hGameWnd, rect), 248, 56, 64) < nSafeValue;
	}

	void CAction::FightingJY(BOOL bHasSummoner, int nZJType, BOOL bAggressiveSkill)
	{
		BOOL bFirstAttack = TRUE;
		BOOL bAltA = FALSE;
		// 1.Ƿս;
		while (IsFighting()) {
			// 2.Ƿҷ;
			while (IsWattingAttack(0)) { // Bug:,޷ж;
				GameGlobal::DebugLog(_T("BattleJYҷ"));
				if (bFirstAttack)
				{
					SRAND(350, 500);	// ʱлҪʱ,ʱʧ;
					GameGlobal::DebugLog(_T("BattleJYһι"));
					// ݽɫѡ;
					SendKey(VK_F2);
					SRAND(300, 350);
					if (bAggressiveSkill) // ;
					{
						MouseClick(CPoint(290 - 3, 140 - 20));
						//MouseMove(hWnd, CPoint(220 - 5, 180 - 10));// ;
						SRAND(350, 500);
					}

					if (bHasSummoner) {
						CRect rc;
						// ٻ޼;
						GameGlobal::DebugLog(_T("BattleJYٻ޼ѡ"));

						// ѡػ;
						if (nZJType) {
							SRAND(150, 350);
							SendKey(VK_S, FALSE, TRUE);
							GameGlobal::DebugLog(_T("BattleJYٻ޼ѡ:%d"), nZJType);
							if (ImgAssist::GetImgMatchtemplate(m_hGameWnd, nZJType == 1 ? GameGlobal::g_strAppdir + _T("img\\\\\\ػ.bmp") : GameGlobal::g_strAppdir + _T("img\\\\\\ػ2.bmp"), rc))
							{
								SRAND(150, 300);
								MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 3, (rc.top + rc.bottom) / 2 + rand() % 3));
							}
						}

						SRAND(300, 500);
						MouseMove(CPoint(290 - 3, 140 - 15));
						MouseClick(CPoint(290 - 3, 140 - 20));
					}

					bFirstAttack = FALSE;
				}
				else
				{
					if (!bAltA)
					{
						bAltA = TRUE;
						// ݽɫѡ;
						SendKey(VK_F1);
						SRAND(300, 350);
						MouseClick(CPoint(230, 180 - 10));// ;
						SRAND(350, 500);
					}
					else {
						GameGlobal::DebugLog(_T("BattleJYǵһι"));
						SendKey(VK_A, FALSE, TRUE);
						SRAND(80, 100);
						if (bFirstAttack) {
							SendKey(VK_A, FALSE, TRUE);
							SRAND(80, 120);
						}
					}
				}
			}

			SRAND(500, 850);
		}

		if (IsSPBelowSafeValue(TRUE, TRUE, 30))
		{
			GameGlobal::DebugLog(_T("SPȫֵ"));
			// Ҽ;
			MouseMove({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2 , (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2  });
			MouseRClick({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2 , (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2 });
		}

		if (bHasSummoner && IsSPBelowSafeValue(FALSE, TRUE, 10))
		{
			GameGlobal::DebugLog(_T("SPȫֵ"));
			// Ҽ;
			MouseMove({ (GameAssist::g_rcSummonerIdleSP.right + GameAssist::g_rcSummonerIdleSP.left) / 2 , (GameAssist::g_rcSummonerIdleSP.bottom + GameAssist::g_rcSummonerIdleSP.top) / 2  });
			MouseRClick({ (GameAssist::g_rcSummonerIdleSP.right + GameAssist::g_rcSummonerIdleSP.left) / 2 , (GameAssist::g_rcSummonerIdleSP.bottom + GameAssist::g_rcSummonerIdleSP.top) / 2  });
		}

		// ս,Ƿƶ;
		if (!IsOnMap(_T("img\\ͼ\\ƶ.bmp"))) {
			// С;
			CRect rc;
			if (!FindNPCByWorldMap("С"))
				return;

			// ѡ;
			BOOL bMatch = FALSE;
			int trySize = 15;
			// Ҫս;
			while (!(bMatch = ClickDlgSetup(_T("img\\\\\\1-Ұץ.bmp")))) {
				SRAND(800, 1200);
				if (!trySize--) break;
			}

			if (bMatch) {
				MouseMove(CPoint(rc.left, rc.top));
				// Ҫս;
				MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2));
				SRAND(1000, 1500);// ȳͼ;

				// ƶһ;
				MouseMove(CPoint(rc.left, rc.top));
				::SetCursorPos(rc.left + rand() % 6, rc.top + rand() % 8);

				// Ƿһνͼ;
				if (ClickDlgSetup(_T("img\\\\\\2-ȥ.bmp")))
				{
					SRAND(600, 1200);
					if (ClickDlgSetup(_T("img\\\\\\3-ս⾵.bmp")))
					{
						SRAND(600, 1800);
						if ((bMatch = ClickDlgSetup(_T("img\\\\\\4-Ҿѡ.bmp"))))
						{
							SRAND(800, 1800);
						}
					}
				}
			}
		}
		else
		{
			// ҵ;
			CRect rc;
			POINT spt[4] = { { 250, 335 }, { 310,360}, { 385, 315}, { 280,295 } };
			for (int i = 0; !ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\\\\\1.bmp"), rc); i++)
			{
				// ͼ;
				SendKey(VK_TAB); SRAND(200, 300);
				// ѡ;
				MouseClick(spt[i % 4]);
				while (ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\ͼ.bmp"), rc)) {
					// ˳ַ;
					SendKey(VK_TAB); SRAND(500, 900);
				}
				// ȴ;
				IsWalkStop();
				// ƶ;
				MouseMove(spt[(i + 1) % 4]);
				if (i > 10) {
					GameGlobal::DebugLog(_T("δҵ+10"));
					break;
				}
			}

			// ҵ;
			MouseMove(CPoint(rc.left + rand() % 10, rc.top + rand() % 10));
			GameGlobal::DebugLog(_T("ƶ"));
			MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 3, (rc.top + rc.bottom) / 2 + rand() % 3));
			SRAND(390, 600);
			// ĿҪֹ꣬ƥʱ굲ס;
			MouseMove(CPoint(rc.right + RAND(10, 20), rc.bottom + RAND(10, 20)));
			SRAND(300, 500);
			GameGlobal::DebugLog(_T("ҵĿ겢ɹ:%s"));

			// ץ;
			if (ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\\\\\ץ.bmp"), rc)) {
				// ҵƥģ;
				SRAND(200, 300);
				//MouseMove(hWnd, CPoint(rc.left + rand() % 10, rc.top + rand() % 10));
				GameGlobal::DebugLog(_T("ץ㣺ƶ"));
				MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 3, (rc.top + rc.bottom) / 2 + rand() % 3));
				SRAND(1000, 1500);
				GameGlobal::DebugLog(_T("ץ㣺ҵĿ겢ɹ:%s"));
			}
		}
	}

	void CAction::FightingYS(LPCTSTR lpszSkillName)
	{
		CRect rc;
		BOOL bBattle = FALSE;
		if (!FindNPCByMap("ҽʦ"))
			return;

		// ϻ˵ʾû;
		rc = FindMatchIcon(_T("img\\gdd\\ϻ˵.bmp"));
		if (!rc.IsRectEmpty() && !rc.IsRectNull())
		{
			// ȷ
			bBattle = TRUE;
			MouseMove({ rc.left - RAND(30, 50), rc.top - RAND(30, 50) });
			SRAND(20, 50);
			MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2));
			SRAND(500, 800); // ͼʱ䳤;
			ClickDlgSetup(_T("img\\ȷ.bmp"));
		}
		else
		{
			rc = FindMatchIcon(_T("img\\gdd\\뿪.bmp"));
			if (!rc.IsRectEmpty() && !rc.IsRectNull())
			{
				// ֻ뿪ѾҼ˳ ;
				GameGlobal::DebugLog("ֻ뿪ѾҼ˳");
				MouseRClick({ rc.left, rc.top });
				SRAND(200, 500);
				return;
			}
			else
			{
				// һҳļܣûһҳ-1ҵ0ûҵ1;
				auto FindNextPageJZ = [&](TCHAR* pJN)->int {
					// ûڵǰҳҵĿ,Ƿһҳ;
					rc = FindMatchIcon(_T("img\\jn-jk\\gdd\\xyy.bmp"));
					if (rc.IsRectEmpty() || rc.IsRectNull())
					{
						// ûһҳ,Ҽ˳;
						MouseRClick();
						SRAND(200, 300);
						return -1;
					}

					MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2));
					SRAND(500, 750);
					// һҳв鿴;
					rc = FindMatchIcon(pJN);
					if (!rc.IsRectEmpty() && !rc.IsRectNull())
					{
						// ҵĿ,;
						MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2));
						SRAND(500, 800);
						ClickDlgSetup(_T("img\\ȷ.bmp"));
						SRAND(350, 500);

						rc = FindMatchIcon(_T("img\\gdd\\ս.bmp"));
						if (!rc.IsRectEmpty() && !rc.IsRectNull())
						{// ڶοʼ;
							// ҵĿ,;
							MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2));
							SRAND(500, 800);
							// ƶ£ֹʶʧ;
							MouseMove({ rc.left, rc.top }, { rc.left - rand() % 20, rc.top - rand() % 20 });
							SRAND(150, 250);
						}

						ClickDlgSetup(_T("img\\ȷ.bmp"));
						SRAND(250, 300);

						// ս;
						return 0;
					}

					return 1;
				};

				TCHAR szJN[MAX_PATH] = { 0 };
				_stprintf_s(szJN, _T("img\\jn-jk\\gdd\\%s.bmp"), lpszSkillName);
				rc = FindMatchIcon(szJN);
				if (rc.IsRectEmpty() || rc.IsRectNull())
				{
					// ֻҳ;
					for (int i = 0; i < 3; i++)
					{
						// ûڵǰҳҵĿ,Ƿһҳ;
						int nRet = FindNextPageJZ(szJN);
						if (nRet == 1)
						{
							// ûҵ;
							SRAND(500, 800);
							continue;
						}

						if (nRet == 0)
						{
							// ҵ;
							bBattle = TRUE;
						}

						break; // ûһҳҲֱbreak;
					}
				}
				else
				{
					bBattle = TRUE;
					// ҵĿ,;
					MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2));
					// ͼʱȽϳ;
					SRAND(500, 800);
					// ս;
					ClickDlgSetup(_T("img\\ȷ.bmp"));
					SRAND(200, 300);
				}
			}
		}

		int KeyValue, SkillTime;
		// ս;
		if (bBattle)
		{
			// Alt+Sʾܣ˫ѡܣ﷢;
			// עе＼̫࣬»йѵ;
			BOOL bRet = FindJNShortCut(lpszSkillName, KeyValue, SkillTime);
			GameGlobal::DebugLog("ݼֵ=%ld", KeyValue);

			// ݼ;
			SendKey(KeyValue);
			SRAND(350, 650);
			// ָλ;
			MouseClick({ 230, 170 });
			SRAND(260, 380);
			// ƶָλ;
			POINT ptDest = { 625, 28 }; // Ͻ;
			MouseMove(ptDest);
			while (IsFighting())
			{
				// жǷҷ;
				if (IsWattingAttack(1))
				{
					SendKey(VK_A, FALSE, TRUE);
				}
				SRAND(500, 900);
			}
		}

		// Ҽ˳;
		SRAND(300, 500); //Ҫĵȴʱ;
		do
		{
			rc = FindMatchIcon("img\\Իرհť.bmp");
			Sleep(900);
		} while (rc.IsRectEmpty() || rc.IsRectNull());

		MouseRClick();
	}

	void CAction::FightingOthers(LPCTSTR lpszName, LPCTSTR lpszSkillName)
	{
		CRect rc;
		BOOL bBattle = FALSE;
		if (!FindNPCByMap(lpszName))
			return;

		// ϻ˵ʾû;
		rc = FindMatchIcon(_T("img\\gdd\\ϻ˵.bmp"));
		if (!rc.IsRectEmpty() && !rc.IsRectNull())
		{
			MouseMove({ rc.left - RAND(30, 50), rc.top - RAND(30, 50) });
			SRAND(120, 150);
			MouseClick(CPoint((rc.right + rc.left) / 2, (rc.top + rc.bottom) / 2));
			SRAND(330, 550);
			// ȷ
			bBattle = TRUE;
			ClickDlgSetup(_T("img\\ȷ.bmp"));
			SRAND(250, 350);
		}
		else
		{
			rc = FindMatchIcon(_T("img\\gdd\\뿪.bmp"));
		}

		int KeyValue, SkillTime;
		if (bBattle) {
			BOOL bRet = FindJNShortCut(lpszSkillName, KeyValue, SkillTime);
			// ƶָλ;
			POINT ptDest = { 625, 28 }; // Ͻ;
			MouseMove(ptDest);
			while (IsFighting())
			{
				// жǷҷ;
				if (IsWattingAttack(1))
				{
					SendKey(VK_A, FALSE, TRUE);
				}

				SRAND(500, 750);
			}
		}

		// Ҽ˳;
		if (_tcsicmp(lpszName, _T("Ƕ")))
		{
			SRAND(300, 500);
			do
			{
				rc = FindMatchIcon("img\\Իرհť.bmp");
				Sleep(900);
			} while (rc.IsRectEmpty() || rc.IsRectNull());

			MouseRClick();
		}
		else
		{
			// صӦ츮;
			MouseMoveEx({ rc.left, rc.top }, { rc.right + rand() % 10, rc.bottom + rand() % 10 });
			ClickDlgSetup(_T("\\img\\gdd\\һӦ츮.bmp"));
		}
	}

	void CAction::OpenChest(int nTimes)
	{
		CRect rc;
		for (int i = 0; i < nTimes; i++)
		{
			if (!ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\\\Ӧ츮.bmp"), rc))
			{
				// ûҵҪĿ;ҪһһνĿĸ״̬ȡ;
				MouseMove({ rc.top - rand() % 5, rc.left - rand() % 5 });
				MouseRClick();
			}
			else
			{
				MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 3, (rc.top + rc.bottom) / 2 + rand() % 5));
				Sleep(600 + rand() % 30);
				// ƶ£߾;
				MouseMove({ rc.top - rand() % 15, rc.left - rand() % 15 });
				// жǷжԻ,ûеĻǵһν;
				if (ImgAssist::GetImgMatchtemplate(m_hGameWnd, GameGlobal::g_strAppdir + _T("img\\\\.bmp"), rc)) {

					MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 2, (rc.top + rc.bottom) / 2 + rand() % 2));
					Sleep(rand() % 200 + 190);
					// Ȼƶȥ;
					//GameGlobal::MouseMove(hProcessMainWnd, CPoint(rc.top - 50 - rand()%20, rc.left - 50 - rand() % 20));
					MouseMoveEx({ rc.top + RAND(0, rc.Height()), rc.left + RAND(0, rc.Width()) });
				}
			}

			Sleep(600 + rand() % 300);
		}
	}

	void CAction::GetSaturdayPresents()
	{
		FindNPCByWorldMap(_T("Э᳤"));
		IsWalkStop();

		if (ClickDlgSetup(_T("img\\\\\\ȡ.bmp")))
		{
			if (ClickDlgSetup(_T("img\\\\\\õ.bmp")))
			{
				FindNPCByWorldMap(_T("ǡͭǮ"));
				IsWalkStop();

				CRect rc;
				//ͭǮ֣õģҪЩʲôأ
				struct MyStruct
				{
					BOOL bDone = FALSE;
					TCHAR szQuestion[MAX_PATH] = { 0 };
				};

				if (ClickDlgSetup(_T("img\\\\\\ͭǮ֣õģҪЩʲôأ.bmp")))
				{
					// һλش;
					std::vector<MyStruct> vtMyst1 = { {FALSE, _T("img\\\\\\ͭǮ֣ɾͥ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ĳ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ܹʶܶ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ϣܹ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ϵͳʱ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣õģʰ.bmp")}
					};

					for (; vtMyst1.size();)
					{
						for (std::vector<MyStruct>::iterator it = vtMyst1.begin(); it != vtMyst1.end(); it++)
						{
							rc = FindMatchIcon(it->szQuestion);
							if (!rc.IsRectEmpty() && !rc.IsRectNull())
							{
								// Ŀش;
								MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 3, (rc.top + rc.bottom) / 2 + rand() % 5));
								// ƶֹ꣬Ӱ´εж;
								MouseMove(CPoint(rc.right + RAND(6, 20), rc.bottom + RAND(6, 20)));
								// ȴһ;
								SRAND(200, 300);
								it = vtMyst1.erase(it);
								break;
							}
						}
					}

					// ڶλش;
					std::vector<MyStruct> vtMyst2 = { {FALSE, _T("img\\\\\\ͭǮ֣ɾͥ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ĳ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ܹʶܶ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ϣܹ.bmp")},
					{FALSE, _T("img\\\\\\ͭǮ֣ϵͳʱ.bmp")}
					};
					for (; vtMyst2.size();)
					{
						for (std::vector<MyStruct>::iterator it = vtMyst2.begin(); it != vtMyst2.end(); it++)
						{
							rc = FindMatchIcon(it->szQuestion);
							if (!rc.IsRectEmpty() && !rc.IsRectNull())
							{
								// Ŀش;
								MouseClick(CPoint((rc.right + rc.left) / 2 + rand() % 3, (rc.top + rc.bottom) / 2 + rand() % 5));
								// ƶֹ꣬Ӱ´εж;
								MouseMove(CPoint(rc.right + RAND(6, 20), rc.bottom + RAND(6, 20)));
								// ȴһ;
								SRAND(200, 300);
								it = vtMyst2.erase(it);
								break;
							}
						}
					}

					// ش,Ҽ˳;
					SRAND(200, 300);
					MouseRClick();
				}

				// ٴλصЭ᳤;
				FindNPCByWorldMap(_T("Э᳤"));
				IsWalkStop();
				// Ҽһ;
				SRAND(200, 300);
				MouseRClick();
				FindNPCByWorldMap(_T("Э᳤"));
				if (ClickDlgSetup(_T("img\\\\\\ãھȥ.bmp")))
				{
					// ȴлͼ;
					SRAND(800, 900);
				}
			}
		}

		if (IsOnMap(_T("img\\ͼ\\꾩.bmp")))
		{
			// Э᳤
			FindNPCByWorldMap(_T("Э᳤"));
			IsWalkStop();
			SRAND(300, 500); // ȶԻ;
			if (ClickDlgSetup(_T("img\\\\\\ȡ.bmp")))
			{
				if (ClickDlgSetup(_T("img\\\\\\õ.bmp")))
				{
					// ͭǮ;
					FindNPCByWorldMap(_T("꡿ͭǮ"));
					IsWalkStop();
					SRAND(300, 500);
					if (ClickDlgSetup(_T("img\\\\\\ͭǮ֣ս.bmp")))
					{
						// ƶָλ;
						POINT ptDest = { 625, 28 }; // Ͻ;
						MouseMove(ptDest);
						while (IsFighting())
						{
							// жǷҷ;
							if (IsWattingAttack(1))
							{
								SendKey(VK_A, FALSE, TRUE);
							}

							SRAND(500, 750);
						}

						// Э᳤;
						FindNPCByWorldMap(_T("Э᳤"));
						IsWalkStop();
						// Ҽһ;
						SRAND(200, 300);
						MouseRClick();
						FindNPCByWorldMap(_T("Э᳤")); SRAND(200, 300);
						if (ClickDlgSetup(_T("img\\\\\\ãھȥ.bmp")))
						{
							// ȴлͼ;
							SRAND(800, 900);
						}
					}
				}
			}
		}

		if (IsOnMap(_T("img\\ͼ\\Ӧ츮.bmp")))
		{
			// Э᳤
			FindNPCByWorldMap(_T("Э᳤"));
			IsWalkStop();
			SRAND(300, 500); // ȶԻ;
			if (ClickDlgSetup(_T("img\\\\\\ȡ.bmp")))
			{
				if (ClickDlgSetup(_T("img\\\\\\õ.bmp")))
				{
					// ͭǮ;
					FindNPCByWorldMap(_T("ӦͭǮ"));
					IsWalkStop();
					SRAND(300, 500);
					if (ClickDlgSetup(_T("img\\\\\\ͭǮ֣ս.bmp")))
					{
						// ƶָλ;
						POINT ptDest = { 625, 28 }; // Ͻ;
						MouseMove(ptDest);
						while (IsFighting())
						{
							// жǷҷ;
							if (IsWattingAttack(1))
							{
								SendKey(VK_A, FALSE, TRUE);
							}

							SRAND(500, 750);
						}

						// Э᳤;
						FindNPCByWorldMap(_T("Э᳤"));
						IsWalkStop();
						SRAND(1000, 2000);
						MouseRClick();
					}
				}
			}
		}
	}

	void CAction::ExerciseSkill(INT nVK_Skill, BOOL bCheckAttack)
	{
		BOOL bFirst = TRUE;
		while (IsFighting())
		{
			if (IsWattingAttack(-1))
			{
				if (bFirst)
				{
					SRAND(250, 350);
					SendKey(nVK_Skill);
					if (bCheckAttack)
					{
						Sleep(30);
						MouseClick({ 226, 158 });
					}
					bFirst = FALSE;
				}
				else
				{
					if (bCheckAttack)
						SendKey(VK_A, FALSE, TRUE);
					else
						SendKey(nVK_Skill);
				}
			}
			Sleep(650);
		}
		
		if (IsSPBelowSafeValue(TRUE, TRUE, 20))
		{
			//DebugLog(_T("SPȫֵ"));
			// Ҽ;
			MouseMove({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2 , (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2 });
			MouseRClick({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2 , (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2 });
		}
	}

	void CAction::StartBattleJY()
	{
		m_hBattleJYEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		if (m_hBattleJYEvent == NULL) {
			_tprintf_s(_T("¼ʧ\n"));
			return;
		}

		m_hBattleJY = CreateThread(NULL, 0, BattleJYThread, this, 0, NULL);
		if (m_hBattleJY == NULL) {
			_tprintf_s(_T("߳ʧ\n"));

			if (m_hBattleJYEvent) {
				SetEvent(m_hBattleJYEvent);
				CloseHandle(m_hBattleJYEvent);
				m_hBattleJYEvent = NULL;
			}
		}
	}

	void CAction::StopBattleJY()
	{
		// ¼ź;
		if (m_hBattleJYEvent)
			SetEvent(m_hBattleJYEvent);

		// ȴ߳̽;
		if (m_hBattleJY) {
			WaitForSingleObject(m_hBattleJY, INFINITE);
			CloseHandle(m_hBattleJY);
			m_hBattleJY = NULL;
		}

		// ر¼;
		if (m_hBattleJYEvent) {
			CloseHandle(m_hBattleJYEvent);
			m_hBattleJYEvent = NULL;
		}

	}

	DWORD __stdcall CAction::BattleJYThread(LPVOID lpParam)
	{
		int i = 0;
		Sleep(20000);
		CAction* pThis = (CAction*)lpParam;
		do
		{
			GameGlobal::DebugLog(_T("start. %d----------------------------"), i);
			pThis->FightingJY(pThis->m_bHasSummoner, pThis->m_nSummonerSkillType, pThis->m_bTargetOfRoleSkill);
			GameGlobal::DebugLog(_T("end. %d----------------------------\n"), i++);
		} while (WaitForSingleObject(pThis->m_hBattleJYEvent, 200) == WAIT_TIMEOUT);

		return 0;
	}

	void CAction::StartSkill()
	{
		m_hBattleJYEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		if (m_hBattleJYEvent == NULL) {
			_tprintf_s(_T("¼ʧ\n"));
			return;
			
		}
		
		m_hBattleJY = CreateThread(NULL, 0, SkillThread, this, 0, NULL);
		if (m_hBattleJY == NULL) {
			_tprintf_s(_T("߳ʧ\n"));
			
			if (m_hBattleJYEvent) {
				SetEvent(m_hBattleJYEvent);
				CloseHandle(m_hBattleJYEvent);
				m_hBattleJYEvent = NULL;
				
			}			
		}
	}
	
	void CAction::StopSkill()
	{
		// ¼ź;
		if (m_hBattleJYEvent)
			SetEvent(m_hBattleJYEvent);
		
		// ȴ߳̽;
		if (m_hBattleJY) {
			WaitForSingleObject(m_hBattleJY, INFINITE);
			CloseHandle(m_hBattleJY);
			m_hBattleJY = NULL;			
		}
		
		// ر¼;
		if (m_hBattleJYEvent) {
			CloseHandle(m_hBattleJYEvent);
			m_hBattleJYEvent = NULL;			
		}
	}
	
	DWORD __stdcall CAction::SkillThread(LPVOID lpParam)
	{
		int i = 0;
		CAction * pThis = (CAction*)lpParam;
		do
		{
			GameGlobal::DebugLog(_T("start. %d----------------------------"), i);
			pThis->ExerciseSkill(pThis->m_nSkillShortcutKey, pThis->m_bTargetOfRoleSkill);
			GameGlobal::DebugLog(_T("end. %d----------------------------\n"), i++);
		} while (WaitForSingleObject(pThis->m_hBattleJYEvent, 200) == WAIT_TIMEOUT);

		return 0;
	}

	void CAction::StartRepeat()
	{
		m_hBattleJYEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
		if (m_hBattleJYEvent == NULL) {
			_tprintf_s(_T("¼ʧ\n"));
			return;

		}

		m_hBattleJY = CreateThread(NULL, 0, RepeatThread, this, 0, NULL);
		if (m_hBattleJY == NULL) {
			_tprintf_s(_T("߳ʧ\n"));

			if (m_hBattleJYEvent) {
				SetEvent(m_hBattleJYEvent);
				CloseHandle(m_hBattleJYEvent);
				m_hBattleJYEvent = NULL;

			}
		}
	}

	void CAction::StopRepeat()
	{
		// ¼ź;
		if (m_hBattleJYEvent)
			SetEvent(m_hBattleJYEvent);

		// ȴ߳̽;
		if (m_hBattleJY) {
			WaitForSingleObject(m_hBattleJY, INFINITE);
			CloseHandle(m_hBattleJY);
			m_hBattleJY = NULL;
		}

		// ر¼;
		if (m_hBattleJYEvent) {
			CloseHandle(m_hBattleJYEvent);
			m_hBattleJYEvent = NULL;
		}
	}

	DWORD __stdcall CAction::RepeatThread(LPVOID lpParam)
	{
		CAction* pAction = (CAction*)lpParam;
		do
		{
			BOOL bFirst = TRUE;
			while (pAction->IsFighting())
			{
				if (pAction->IsWattingAttack(-1))
				{
					pAction->SendKeyFast(VK_A, FALSE, TRUE);
				}
			}

			if (pAction->IsSPBelowSafeValue(TRUE, TRUE, 50))
			{
				// Ҽ;
				pAction->MouseMove({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2, (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2 });
				pAction->MouseRClick({ (GameAssist::g_rcRoleIdleSP.right + GameAssist::g_rcRoleIdleSP.left) / 2, (GameAssist::g_rcRoleIdleSP.bottom + GameAssist::g_rcRoleIdleSP.top) / 2 });
			}
		} while (WaitForSingleObject(pAction->m_hBattleJYEvent, 50) == WAIT_TIMEOUT);

		return 0;
	}

	void LoadMetaGraph()
	{
		// xml;
		tinyxml2::XMLDocument doc;
		if (tinyxml2::XML_SUCCESS != doc.LoadFile("metagraph.xml")) {
			return;
		}

		tinyxml2::XMLElement* pXmlRoot = NULL;
		if ((pXmlRoot = doc.RootElement()) == NULL)
			return;

		tinyxml2::XMLElement* pXmlElent = pXmlRoot->FirstChildElement();
		while (pXmlElent) 
		{
			if (_tcsicmp(pXmlElent->Value(), _T("meta")) == 0) 
			{
				METAGRAPH cItem;
				cItem.name = pXmlElent->Attribute("name");
				cItem.file_path = pXmlElent->Attribute("file");
				cItem.desc = pXmlElent->Attribute("desc");
				std::string zone = pXmlElent->Attribute("lookupZone");
				// ȥո;
				zone.erase(std::remove_if(zone.begin(), zone.end(), [](unsigned char x) {return std::isspace(x); }), zone.end()); //C++17
#if 0
				char x[5] = { 0 };
				char y[5] = { 0 };
				char width[5] = { 0 };
				char height[5] = { 0 };
				if (_stscanf_s(zone.c_str(), "{x=%[^,],y=%[^,],width=%[^,],height=%s}", x, 5, y, 5, width, 5, height, 5) == 4)
				{
					cItem.x = atoi(x);
					cItem.y = atoi(y);
					cItem.width = atoi(width);
					cItem.height = atoi(height);
				}
#else
				_stscanf_s(zone.c_str(), "{x=%d,y=%d,width=%d,height=%d}", &cItem.x, &cItem.y, &cItem.width, &cItem.height);
#endif
				cItem.LoadImage();
				g_mapMetaGraph.insert(std::pair<std::string, METAGRAPH>(cItem.name, cItem));
			}

			pXmlElent = pXmlElent->NextSiblingElement();
		}

	}
};